/* Where the note database is placed. */
#define DB "/usr/local/etc/httpd/htdocs/board/notes.db"

/* Where the 'after note adding' page is placed. */
#define AM "Location: http://pfawww.pp.se/board/notboard.html"

/* Size of the noteboard. 
 * 
 * The size of the board doesn't make much difference for evaluating
 * things, just remember that notes far to the bottom/right of the 
 * board won't be shown.
 */
#define X_BOARD_SIZE 728
#define Y_BOARD_SIZE 728

/* Maximum number of rows and cols for a note.
 * 
 * The database is fixed with this length, try to keep the row value
 * as low as possible to optimize things.
 */
#define MAX_ROWS 10
#define MAX_COLS 41

/* Which font to use for the notes. 
 *
 * You can choose between t(iny), s(mall), m(edium)b(old), l(arge)
 * and g(iant) in version 1.2 of GD. 
 */
#include "font.h"
#define FONT gdFontNoteBoard

/* Don't touch the rest, leave it alone, go away. */
char *parse();

typedef struct {
  
  char txt[MAX_ROWS][MAX_COLS];
  int posx, posy;
  int rcolor, bcolor, tcolor;
  
} NOTE;
