#include <stdio.h>
#include <pwd.h>
#ifdef DGUX
#include <crypt.h>
#else
extern char *crypt();
#endif

#ifdef USE_BP
#include "bpasswd.h"
#endif


char *sstrdup();

#ifdef USE_BP
getuserinfo(username,passwd,spoolfile,rpop_flag,des)
     char *username,*passwd;
     char **spoolfile;
     int rpop_flag,des;
{
  struct bpasswd *p;
  static struct passwd *p2;
  char buf[512];
  int len;

#ifdef USE_RPOP
  if(rpop_flag) {
    if(!check_rpop(des,username,passwd)) return(1);
    p=getuserdbsecondary(username,"popmail,magnus","");
    if(p==NULL) p=getuserdbprimary(username,"popmail,magnus","");
  }
  else
#endif
    {
      p=vrfyusersecondaryid(username,passwd,"popmail,magnus","");
      if(p==NULL) {
	p=vrfyuserprimaryid(username,passwd,"popmail,magnus","");
      }
    }
  unlink_tkt_fl();
  if(p==NULL) return(1);
  else {
    p2=getpwnam(p->pw_name);
    if(p2!=NULL) strcpy(buf,"/usr/spool/mail/");
    else {
      strcpy(buf,p->pw_dir);
      len=strlen(buf);
      if(buf[len-1]!='/') {
	buf[len]='/';
	buf[len+1]=0;
      }
    }
    strcat(buf,p->pw_name);
    (*spoolfile)=sstrdup(buf);
    return(0);
  }
}
#else
/* Verifies a user. If rpop_flag is set, then the user is attempting to
   login with RPOP (passwd is then the remote user's username). des
   is the socket associated with the session. spoolfile will be set
   to point to a malloc()ed string containing the person's spool file.

   Returns 1 on failure, 0 on success. */

getuserinfo(username,passwd,spoolfile,rpop_flag,des)
     char *username,*passwd;
     char **spoolfile;
     int rpop_flag;
     int des;
{
  struct passwd *p;
  static struct passwd *p2;
  char buf[512];
  int len;

  if(rpop_flag) {
    if(!check_rpop(des,username,passwd)) return(1);
  }
  p=getpwnam(username);
  if(p==NULL) return(1);
  if(!rpop_flag) {
    if(strcmp(crypt(passwd,p->pw_passwd),p->pw_passwd)) return(1);
  }
  strcpy(buf,"/usr/spool/mail/");
  strcat(buf,p->pw_name);
  (*spoolfile)=sstrdup(buf);
  return(0);
}
#endif
