#include <stdio.h>
#include "mymalloc.h"

static struct userlist {
  char *name;
  struct userlist *prev,*next;
} *userlist=NULL;

struct userlist *add_username(name)
     char *name;
{
  struct userlist *p;

  for(p=userlist;p!=NULL;p=p->next) {
    if(name[0]==p->name[0] && strcmp(p->name,name)==0) return(NULL);
  }
  p=tmalloc(struct userlist);
  p->next=userlist;
  if(userlist!=NULL) userlist->prev=p;
  p->prev=NULL;
  userlist=p;
  p->name=name;
  return(p);
}

delete_username(ptr)
     struct userlist *ptr;
{
  if(ptr==NULL) return;
  if(userlist==ptr) {
    userlist=ptr->next;
    if(userlist!=NULL) userlist->prev=NULL;
  }
  else {
    if(ptr->next!=NULL) ptr->next->prev=ptr->prev;
    if(ptr->prev!=NULL) ptr->prev->next=ptr->next;
  }
  free(ptr);
}
